/***************************************************************************
* globalstructs.c: contains all structures that are used from various	   *
*		   modules (e.g. all the OK-gadgets)                       *
*		   may be used by declaring them as external objects in    *
*		   the modules						   *
*									   *
* created: ??? unknown - somewhere in early 1991			   *
* updated: 13-Apr-91 Mtwx						   *
***************************************************************************/

#include <intuition/intuition.h>

SHORT OKBorderVectors[] = {
	0,0,
	91,0,
	91,17,
	0,17,
	0,0
};
struct Border OKBorder = {
	-1,-1,	/* XY origin relative to container TopLeft */
	3,0,JAM1,	/* front pen, back pen and drawmode */
	5,	/* number of XY vectors */
	OKBorderVectors, /* pointer to XY vectors */
	NULL	/* next border in list */
};

struct IntuiText OKText = {
	1,0,JAM1,	/* front and back text pens, drawmode and fill byte */
	33,4,	/* XY origin relative to container TopLeft */
	NULL,	/* font pointer or NULL for default */
	(UBYTE *)"OK!", /* pointer to text */
	NULL	/* next IntuiText structure */
};

/* Now the borders for ALL string gadgets: */
/*			(not for all in the current version (2.03), but I'm
			 working on it!) */

/* Border vectors assigned to NULL! The borders are used from different
   modules and must be declared as extern there. Then local borders are
   made by assiging local border structures to the globals in here (see
   below):

     extern struct Border StringGBorder1;
     .
     .
     .
     static struct Border LocalBorder;
     static SHORT LocalVectors[]={ three pairs of coordinates };
     .
     LocalBorder = StringGBorder1;
     LocalBorder.XY=LocalVectors;

   The border vectors must be defined in the modules. This allows several
   string gadgets to use the same two border definitions. Saving a lot of
   memory I guess! In addition you must set the NextBorder field in your
   first border to the second one! */

struct Border StringGBorder2 = { -2,-2,2,0,JAM1,3,NULL,NULL };
struct Border StringGBorder1 = { -2,-2,1,0,JAM1,3,NULL,NULL };

/* Now some Images */

/* Images for a toggle gadget (without - with checkmark) */

#define toggle1_iff_width 26
#define toggle1_iff_height 11
#define toggle1_iff_num_planes 4
#define toggle1_iff_words_per_plane 22

UWORD __chip toggle1_iff_data[4][11][2] = {    /* without checkmark */
    {
	0x0000,0x0040,0x0000,0x00c0,0x0000,0x00c0,0x0000,0x00c0,
	0x0000,0x00c0,0x0000,0x00c0,0x0000,0x00c0,0x0000,0x00c0,
	0x0000,0x00c0,0x0000,0x00c0,0x7fff,0xffc0
    },
    {
	0xffff,0xff80,0xc000,0x0000,0xc000,0x0000,0xc000,0x0000,
	0xc000,0x0000,0xc000,0x0000,0xc000,0x0000,0xc000,0x0000,
	0xc000,0x0000,0xc000,0x0000,0x8000,0x0000
    },
    {
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000
    },
    {
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000
    },
};

#define toggle2_iff_width 26
#define toggle2_iff_height 11
#define toggle2_iff_num_planes 4
#define toggle2_iff_words_per_plane 22

UWORD __chip toggle2_iff_data[4][11][2] = {  /* with checkmark */
    {
	0x0000,0x0040,0x0000,0x00c0,0x0000,0x70c0,0x0000,0xc0c0,
	0x0001,0x80c0,0x01c3,0x00c0,0x00e6,0x00c0,0x007c,0x00c0,
	0x0038,0x00c0,0x0000,0x00c0,0x7fff,0xffc0
    },
    {
	0xffff,0xff80,0xc000,0x0000,0xc000,0x0000,0xc000,0x0000,
	0xc000,0x0000,0xc000,0x0000,0xc000,0x0000,0xc000,0x0000,
	0xc000,0x0000,0xc000,0x0000,0x8000,0x0000
    },
    {
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000
    },
    {
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000
    },
};

struct Image ToggleImg1 =
{
  0, 0, toggle1_iff_width, toggle1_iff_height, toggle1_iff_num_planes,
  (USHORT *)toggle1_iff_data, 0xF, 0, NULL
};

struct Image ToggleImg2 =
{
  0, 0, toggle2_iff_width, toggle2_iff_height, toggle2_iff_num_planes,
  (USHORT *)toggle2_iff_data, 0xF, 0, NULL
};

#define boolg1_iff_width 90
#define boolg1_iff_height 14
#define boolg1_iff_num_planes 4
#define boolg1_iff_words_per_plane 84

UWORD __chip boolg1_iff_data[4][14][6] = {
    {
	0xffff,0xffff,0xffff,0xffff,0xffff,0xffc0,0xc000,0x0000,
	0x0000,0x0000,0x0000,0x00c0,0xc000,0x0000,0x0000,0x0000,
	0x0000,0x00c0,0xc000,0x0000,0x0000,0x0000,0x0000,0x00c0,
	0xc000,0x0000,0x0000,0x0000,0x0000,0x00c0,0xc000,0x0000,
	0x0000,0x0000,0x0000,0x00c0,0xc000,0x0000,0x0000,0x0000,
	0x0000,0x00c0,0xc000,0x0000,0x0000,0x0000,0x0000,0x00c0,
	0xc000,0x0000,0x0000,0x0000,0x0000,0x00c0,0xc000,0x0000,
	0x0000,0x0000,0x0000,0x00c0,0xc000,0x0000,0x0000,0x0000,
	0x0000,0x00c0,0xc000,0x0000,0x0000,0x0000,0x0000,0x00c0,
	0xc000,0x0000,0x0000,0x0000,0x0000,0x00c0,0xffff,0xffff,
	0xffff,0xffff,0xffff,0xffc0
    },
    {
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x3fff,0xffff,
	0xffff,0xffff,0xffff,0xff00,0x3000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x3000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x3000,0x0000,0x0000,0x0000,0x0000,0x0000,0x3000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x3000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x3000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x3000,0x0000,0x0000,0x0000,0x0000,0x0000,0x3000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x3000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x3000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x3000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000
    },
    {
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000
    },
    {
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000
    },
};

struct Image BoolImage1 =
{
  0, 0, boolg1_iff_width, boolg1_iff_height, boolg1_iff_num_planes,
  (USHORT *)boolg1_iff_data, 0xF, 0, NULL
};

